Index: trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/project/documents/layout/report/LayoutReportActionParametersImpl.java
===================================================================
--- trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/project/documents/layout/report/LayoutReportActionParametersImpl.java	(revision 0)
+++ trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/project/documents/layout/report/LayoutReportActionParametersImpl.java	(revision 1608)
@@ -0,0 +1,408 @@
+/*
+ * To change this license header, choose License Headers in Project Properties.
+ * To change this template file, choose Tools | Templates
+ * and open the template in the editor.
+ */
+package org.gvsig.app.project.documents.layout.report;
+
+import java.io.ByteArrayInputStream;
+import java.io.ByteArrayOutputStream;
+import java.io.IOException;
+import java.io.InputStream;
+import java.nio.charset.StandardCharsets;
+import java.util.List;
+import javax.json.JsonNumber;
+import javax.json.JsonObject;
+import org.apache.commons.codec.DecoderException;
+import org.apache.commons.codec.binary.Hex;
+import org.apache.commons.io.IOUtils;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.app.project.documents.Document;
+import org.gvsig.app.project.documents.layout.LayoutDocument;
+import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.mapcontext.MapContextLocator;
+import org.gvsig.fmap.mapcontext.rendering.symbols.ISymbol;
+import org.gvsig.json.Json;
+import org.gvsig.json.JsonObjectBuilder;
+import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.dispose.DisposeUtils;
+import org.gvsig.tools.persistence.PersistenceManager;
+import org.gvsig.tools.persistence.PersistentState;
+import org.gvsig.tools.persistence.exception.PersistenceException;
+import org.gvsig.tools.resourcesstorage.ResourcesStorage;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+/**
+ *
+ * @author fdiaz
+ */
+public class LayoutReportActionParametersImpl implements LayoutReportActionParameters {
+    private static final Logger LOGGER = LoggerFactory.getLogger(LayoutReportActionParametersImpl.class);
+
+    private final String LAYOUT_REPORT_BUFFER_SIZE = "bufferSize";
+    private final String LAYOUT_REPORT_CENTER_TO_CURRENT_ROW = "centerToCurrentRow";
+    private final String LAYOUT_REPORT_DEFAULT_TEMPLATE_NAME = "layout";
+    private final String LAYOUT_REPORT_LABEL = "label";
+    private final String LAYOUT_REPORT_NAME = "name";
+    private final String LAYOUT_REPORT_TEMPLATE_NAME = "templateName";
+    private final String LAYOUT_REPORT_HIGHLIGHT_RECORD = "highlightRecord";
+    private final String LAYOUT_REPORT_HIGHLIGHT_SYMBOL = "highlightSymbol";
+    private final String LAYOUT_REPORT_SYMBOL_TO_RECORD = "applySymbolToRecord";
+    private final String LAYOUT_REPORT_SYMBOL_TO_EVERYTHING_EXCEPT_RECORD = "applySymbolToEverythinfExceptRecord";
+    private final String LAYOUT_REPORT_TYPE = "type";
+    private final String LAYOUT_REPORT_VIEW_TAG = "viewTag";
+    private final String LAYOUT_REPORT_USE_INTERNAL_PDF_VIEWER = "useInternalPdfViewer";
+    private final String LAYOUT_REPORT_ZOOM_TO_CURRENT_ROW = "zoomToCurrentRow";
+    
+    private String identifier;
+    private String label;
+    private boolean centerToCurrentRow;
+    private boolean zoomToCurrentRow;
+    private double bufferSize;
+    private boolean useInternalPdfViewer;
+    private boolean highlightRecord;
+    private String viewTag;
+    private ISymbol highlightSymbol;
+    private String highlightSymbolSerialized;
+    private boolean applySymbolToRecord;
+    private boolean applySymbolToEverythingExceptRecord;
+    private String templateName;
+
+    LayoutReportActionParametersImpl() {
+    }
+
+    LayoutReportActionParametersImpl(String name) {
+        this.identifier = name;
+        this.label = name;
+    }
+    
+    
+    @Override
+    public String getIdentifier() {
+        return identifier;
+    }
+
+    @Override
+    public void setIdentifier(String identifier) {
+        this.identifier = identifier;
+    }
+
+    @Override
+    public String getLabel() {
+        return this.label;
+    }
+
+    @Override
+    public void setLabel(String label) {
+        this.label = label;
+    }
+
+    @Override
+    public boolean isCenterToCurrentRow() {
+        return this.centerToCurrentRow;
+    }
+
+    @Override
+    public void setCenterToCurrentRow(boolean centerToCurrentRow) {
+        this.centerToCurrentRow = centerToCurrentRow;
+    }
+
+    @Override
+    public boolean isZoomToCurrentRow() {
+        return this.zoomToCurrentRow;
+    }
+
+    @Override
+    public void setZoomToCurrentRow(boolean zoomToCurrentRow) {
+        this.zoomToCurrentRow = zoomToCurrentRow;
+    }
+
+    @Override
+    public double getBufferSize() {
+        return this.bufferSize;
+    }
+
+    @Override
+    public void setBufferSize(double bufferSize) {
+        this.bufferSize = bufferSize;
+    }
+
+    @Override
+    public boolean isHighlightRecord() {
+        return this.highlightRecord;
+    }
+
+    @Override
+    public void setHighlightRecord(boolean b) {
+        this.highlightRecord = b;
+    }
+    
+    @Override
+    public boolean isApplySymbolToRecord() {
+        return this.applySymbolToRecord;
+    }
+
+    @Override
+    public void setApplySymbolToRecord(boolean b) {
+        this.applySymbolToRecord = b;
+    }
+
+    @Override
+    public boolean isApplySymbolToEverythingExceptRecord() {
+        return this.applySymbolToEverythingExceptRecord;
+    }
+
+    @Override
+    public void setApplySymbolToEverythingExceptRecord(boolean b) {
+        this.applySymbolToEverythingExceptRecord = b;
+    }
+
+    @Override
+    public boolean isUseInternalPdfViewer() {
+        return useInternalPdfViewer;
+    }
+
+    @Override
+    public void setUseInternalPdfViewer(boolean useIntervalPdfViewer) {
+        this.useInternalPdfViewer = useIntervalPdfViewer;
+    }
+    
+    @Override
+    public String getViewTag() {
+        return this.viewTag;
+    }
+
+    @Override
+    public void setViewTag(String viewTag) {
+        this.viewTag = viewTag;
+    }
+
+    @Override
+    public ISymbol getHighlightSymbol(FeatureStore featureStore) {
+        if(this.highlightSymbol == null){
+            this.highlightSymbol = createSymbol(featureStore, this.highlightSymbolSerialized);
+        }
+        return this.highlightSymbol;
+    }
+
+    @Override
+    public void setHighlightSymbol(ISymbol symbol) {
+        this.highlightSymbol = symbol;
+        this.highlightSymbolSerialized = null;
+    }
+    
+    @Override
+    public String getHighlightSymbolSerialized() {
+        if(this.highlightSymbolSerialized == null){
+            this.highlightSymbolSerialized = createSymbolSerialized(this.highlightSymbol);
+        }
+        return this.highlightSymbolSerialized;
+    }
+
+    @Override
+    public void setHighlightSymbolSerialized(String symbol) {
+        this.highlightSymbolSerialized = symbol;
+        this.highlightSymbol = null;
+    }
+    
+    @Override
+    public String getTemplateName() {
+        return this.templateName;
+    }
+    
+    @Override
+    public void setTemplateName(String templateName) {
+        this.templateName = templateName;
+    }
+
+    private static ISymbol createSymbol(FeatureStore featureStore, String s) {
+        FeatureAttributeDescriptor geomAttr = featureStore.getDefaultFeatureTypeQuietly().getDefaultGeometryAttribute();
+        if (geomAttr == null) {
+            return null;
+        }
+        int geomType = geomAttr.getGeomType().getType();
+
+        try {
+            if (StringUtils.isBlank(s)) {
+                return MapContextLocator.getMapContextManager().createSymbol(geomType);
+            }
+
+            byte[] bytes = Hex.decodeHex(s.toCharArray());
+            PersistenceManager persistenceManager = ToolsLocator.getPersistenceManager();
+            InputStream in = new ByteArrayInputStream(bytes);
+            ISymbol symbol = (ISymbol) persistenceManager.getObject(in);
+            return symbol;
+        } catch (DecoderException ex) {
+            return MapContextLocator.getMapContextManager().createSymbol(geomType);
+        }
+
+    }
+    
+    private static String createSymbolSerialized(ISymbol symbol){
+        try {
+            if(symbol == null){
+                return null;
+            }
+            PersistenceManager persistenceManager = ToolsLocator.getPersistenceManager();
+            PersistentState state = persistenceManager.getState(symbol);
+            ByteArrayOutputStream out = new ByteArrayOutputStream();
+            persistenceManager.saveState(state, out);
+            return Hex.encodeHexString(out.toByteArray());
+        } catch (Exception ex) {
+            throw new RuntimeException("Can't persist symbol", ex);
+        }
+    }
+    
+
+    @Override
+    public void fromJson(JsonObject json) {
+    this.templateName = json.getString(LAYOUT_REPORT_TEMPLATE_NAME, LAYOUT_REPORT_DEFAULT_TEMPLATE_NAME); // "1.layout"...
+    
+    this.identifier = json.getString(LAYOUT_REPORT_NAME, null);
+    this.label = json.getString(LAYOUT_REPORT_LABEL, this.identifier);
+    this.highlightRecord = json.getBoolean(LAYOUT_REPORT_HIGHLIGHT_RECORD, true);
+    this.highlightSymbol = null;
+    this.highlightSymbolSerialized = json.getString(LAYOUT_REPORT_HIGHLIGHT_SYMBOL, null);
+    this.applySymbolToRecord = json.getBoolean(LAYOUT_REPORT_SYMBOL_TO_RECORD, false);
+    this.applySymbolToEverythingExceptRecord = json.getBoolean(LAYOUT_REPORT_SYMBOL_TO_EVERYTHING_EXCEPT_RECORD, false);
+
+    this.centerToCurrentRow = json.getBoolean(LAYOUT_REPORT_CENTER_TO_CURRENT_ROW, true);
+    this.zoomToCurrentRow = json.getBoolean(LAYOUT_REPORT_ZOOM_TO_CURRENT_ROW, true);
+    this.bufferSize = 0.0;
+    if(json.containsKey(LAYOUT_REPORT_BUFFER_SIZE)){
+        JsonNumber theSize = json.getJsonNumber(LAYOUT_REPORT_BUFFER_SIZE);
+        if(theSize != null){
+            this.bufferSize = theSize.doubleValue();
+        }
+    } 
+    this.setViewTag(json.getString(LAYOUT_REPORT_VIEW_TAG, null));
+    this.useInternalPdfViewer = json.getBoolean(LAYOUT_REPORT_USE_INTERNAL_PDF_VIEWER, true);
+    }
+
+    @Override
+    public JsonObjectBuilder toJsonBuilder() {
+        JsonObjectBuilder jsonBuilder = Json.createObjectBuilder();
+        jsonBuilder.add(LAYOUT_REPORT_NAME, this.identifier);
+        jsonBuilder.add(LAYOUT_REPORT_TYPE, LayoutReportActionFactory.LAYOUT_REPORT_ACTION_NAME);
+        jsonBuilder.add(LAYOUT_REPORT_LABEL, this.label);
+        jsonBuilder.add(LAYOUT_REPORT_TEMPLATE_NAME, this.templateName);
+        if (highlightSymbol != null) {
+            jsonBuilder.add(LAYOUT_REPORT_HIGHLIGHT_SYMBOL, this.getHighlightSymbolSerialized());
+        }
+        jsonBuilder.add(LAYOUT_REPORT_CENTER_TO_CURRENT_ROW, this.centerToCurrentRow);
+        jsonBuilder.add(LAYOUT_REPORT_ZOOM_TO_CURRENT_ROW, this.zoomToCurrentRow);
+        jsonBuilder.add(LAYOUT_REPORT_BUFFER_SIZE, this.bufferSize);
+        jsonBuilder.add(LAYOUT_REPORT_HIGHLIGHT_RECORD, this.highlightRecord);
+        jsonBuilder.add(LAYOUT_REPORT_SYMBOL_TO_RECORD, this.applySymbolToRecord);
+        jsonBuilder.add(LAYOUT_REPORT_SYMBOL_TO_EVERYTHING_EXCEPT_RECORD, this.applySymbolToEverythingExceptRecord);
+        jsonBuilder.add(LAYOUT_REPORT_VIEW_TAG, this.viewTag);
+        jsonBuilder.add(LAYOUT_REPORT_USE_INTERNAL_PDF_VIEWER, this.useInternalPdfViewer);
+        
+        return jsonBuilder;
+    }
+
+    @Override
+    public void save(FeatureStore store, LayoutDocument layout) throws IOException {
+        ResourcesStorage.Resource resource = null;
+        ResourcesStorage.Resource resourceLayout = null;
+        boolean persistentIndependentSave = false;
+        try {
+            ResourcesStorage resources = store.getResourcesStorage();
+            
+            String resourceName = getResourceName(resources, this.identifier);
+            if(resourceName == null){
+                resourceName = getNextResourceName(resources, "report");
+            }
+            String theTemplateName = this.templateName;
+            if(StringUtils.isBlank(this.templateName)){
+                theTemplateName = LayoutReportActionFactory.LAYOUT_REPORT_ACTION_NAME;
+                if(StringUtils.contains(resourceName, resources.getSeparator())){
+                    theTemplateName = StringUtils.replaceIgnoreCase(
+                            resourceName, 
+                            resources.getSeparator()+"report", 
+                            resources.getSeparator()+LayoutReportActionFactory.LAYOUT_REPORT_ACTION_NAME);
+                }
+                this.templateName = theTemplateName;
+            }
+            
+            resource = resources.getResource(resourceName);
+            IOUtils.write(this.toJson().toString(), resource.asOutputStream(), StandardCharsets.UTF_8);
+            
+            if(layout != null) {
+                persistentIndependentSave = layout.isPersistIndependent();
+                resourceLayout = resources.getResource(theTemplateName);
+                PersistenceManager persistenceManager = ToolsLocator.getPersistenceManager();
+                layout.setPersistIndependent(true);
+                PersistentState persistentState = persistenceManager.getState(layout.getMainWindow());
+                persistenceManager.saveState(persistentState, resourceLayout.asOutputStream());
+            }
+        } catch (PersistenceException ex) {
+            throw new IOException("Can't persist LayoutReportActionParameters", ex);
+        } finally {
+            if(layout != null){
+                layout.setPersistIndependent(persistentIndependentSave);
+            }
+            IOUtils.closeQuietly(resource);
+            IOUtils.closeQuietly(resourceLayout);
+        }
+    }
+    
+    private String getNextResourceName(ResourcesStorage resources, String resourceName){
+        List<ResourcesStorage.Resource> reports = resources.getResources(resourceName);
+        if(reports == null || reports.isEmpty()){
+            return resourceName;
+        }
+        int n = -1;
+        for (ResourcesStorage.Resource report : reports) {
+            if(StringUtils.contains(report.getName(), resources.getSeparator())){
+                String[] s = StringUtils.split(report.getName(), resources.getSeparator());
+                n = Math.max(n, Integer.parseInt(s[0]));
+            } else {
+                n=0;
+            }
+        }
+        
+        if (n < 0) {
+            return resourceName;
+        }
+        
+        n++;
+        return String.valueOf(n) + resources.getSeparator() + resourceName;
+
+        
+    }
+    
+    private String getResourceName(ResourcesStorage resources, String reportName) {
+        try {
+            if (resources != null) {
+                List<ResourcesStorage.Resource> reportsResources = resources.getResources("report");
+                if (reportsResources != null && !reportsResources.isEmpty()) {
+                    for (ResourcesStorage.Resource resource : reportsResources) {
+                        InputStream is = null;
+                        try {
+                            is = resource.asInputStream();
+                            JsonObject json = javax.json.Json.createReader(is).readObject();
+                            String name = json.getString(LAYOUT_REPORT_NAME, null);
+                            if(StringUtils.equalsIgnoreCase(name, reportName)){
+                                return resource.getName();
+                            }
+                        } catch (Exception ex) {
+                            LOGGER.warn("Can't load report form resource (" + resource.getURL() + ")", ex);
+                        } finally {
+                            IOUtils.closeQuietly(is);
+                        }
+                        DisposeUtils.disposeQuietly(resource);
+                    }
+                }
+            }
+        } finally {
+            DisposeUtils.disposeQuietly(resources);
+        }
+        return null;
+    }
+    
+    
+    
+}
